/***********************************************************/
/*                                               2/23/87   */
/*     RASTER SPRITE EDITOR / GRAPHICS SHELL               */
/*                Version 1.51                             */
/*                                                         */
/*  Functional Notes:                                      */
/*      All graphic (raster) operations are done on        */
/*  the HIDDEN buffer. When the operation is completed     */
/*  the SHOWN and HIDDEN buffers are toggled. The new      */
/*  SHOWN is the current video ram. The current Picture    */
/*  BUFFER is then copied into the new HIDDEN.             */
/*      The HIDDEN buffer also serves as temporary         */
/*  storage for the Restore and Save as Hex functions.     */
/*                                              -PDB       */
/***********************************************************/
#include "raster.h"
#include <fcntl.h>
#include <gemdefs.h>
#include <obdefs.h>
#include <osbind.h>
#include <stdio.h>
#include <string.h>
#define or ||
#define OK 1
#define NO 2
#define LEFT 1
#define RIGHT 2
#define TOP_MENU 1
#define DEMO_MENU 0
#define LOAD 1
#define SAVE 2
#define TRUE 1
#define FALSE 0
#define CANCEL 0
#define LOW 0
#define MEDIUM 1
#define HIGH 2
#define MORE 2
#define RING_BELL() Bconout(2,7)
#define HELP 0x620000L
#define UNDO 0x610000L

		extern int	gl_apid;

		int desk_palette[16],pic1_palette[16],*palette,
			pic2_palette[16],sprite_palette[16],
			my_palette[16] = {0x000,0x700,
			0x007,0x777,0x111,0x222,0x333,
			0x444,0x555,0x666,0x047,0x470,
			0x407,0x740,0x074,0x777   };

		int	gl_hchar,gl_wchar,gl_wbox,gl_hbox,handle,ap_id,
			contrl[12],intin[128],ptsin[128],intout[128],wind_id,
			ptsout[128],work_in[11],work_out[57],nplanes;

		int message[8],I,J,K,key,button,x,y,n,response,but,
			state,event,p[8],rez,width=1,height=1,r_w,r_h,
			header[2],filler[46],active_menu = TOP_MENU,
			finished = FALSE,blit_mode = 3,old_mode = M3,
			auto_mouse_repeat = FALSE,mask_exists,clip[4],
			alter_flag = 0,touch_up_color = 1,done_touching_up,
			box[4] = { 120,154,160,174 },draw_mode,fill_index = 8,
			t_response;


		long menu1_address,menu2_address,menu3_address,
			 menu_address,temp,offset[2],SCREEN1,SCREEN2,SPRITE,
			 MASK,SHOWN,HIDDEN,BUFFER1,BUFFER2,BUFFER,buffer;

		char default_drive,filename[40],*done="[1][    ][OK]";


main()
	{
	setup();
	while( finished != TRUE ) get_menu_event();
	exit_to_desktop();
	}



get_menu_event()
	{
	event = evnt_multi(MU_MESAG | MU_BUTTON | MU_KEYBD,
			1,3,1,0,0,0,0,0,0,0,0,0,0,message,0,0,&x,&y,
			&button,&state,&key,&n);
	reset_palette();
	if	(event == MU_KEYBD)
	{
	if (active_menu == TOP_MENU) finished = TRUE;
	goto TOP;
	}
	if	(message[0]==10)
	{
	switch(active_menu)
	 {
 case TOP_MENU:		/***** 1st MENU BAR SELECT-ABLES *****/
		switch(message[4])
		{
		case RASTER:
			introduction();
			break;
		case NEO:
		case DEGAS:
			menu_bar(menu1_address,FALSE);
			response=select_picture(message[4],LOAD);
			if(response!=CANCEL) load_picture();
			else show_picture(BUFFER);
			menu_bar(menu1_address,TRUE);
			break;
		case LOADSPR:
			set_restrictions(TRUE);
			set_mask_restictions(FALSE);
			load_sprite();
			break;
		case SHOW_SPR:
			menu_bar(menu1_address,FALSE);
			show_sprite();
			menu_bar(menu1_address,TRUE);
			break;
		case SAVEPIC:
			save_background(SAVE);
			break;
		case APPEND:
			save_backgound(APPEND);
			break;
		case SPR:
		case MASK_SPR:
			menu_bar(menu1_address,FALSE);
			save_spr();
			menu_bar(menu1_address,TRUE);
			break;
		case HEX:
		case MASK_HEX:
			menu_bar(menu1_address,FALSE);
			save_hex();
			menu_bar(menu1_address,TRUE);
			break;
		case NEXTMENU:
			menu_tnormal(menu1_address,message[3],1);
			menu_bar(menu1_address,FALSE);
			menu_bar(menu2_address,TRUE);
			active_menu = DEMO_MENU;
			menu_address = menu2_address;
			clear_message_buffer();
			RING_BELL();
			break;
		case RUN_NEO:
			call_neochrome();
			break;
		case RUN_DGAS:
			call_degas();
			break;
		case OTHERPRG:
			call_other_program();
			break;
		case GOOD_BYE:
			finished = TRUE;
			break;
	 	}
		break;


 case DEMO_MENU:		/***** 2nd MENU BAR SELECT-ABLES *****/
		menu_ienable(menu2_address,RESTORE,FALSE);
		switch(message[4])
		{
		case REPEAT:
			set_auto_repeat();
			break;
		case EDITSPR:
			set_restrictions(TRUE);
			set_mask_restrictions(FALSE);
			edit();
			break;
		case PASTE:
		case MASKPAST:
			paste_sprite();
			break;
		case TOUCH_UP:
			do_touch_up();
			break;
		case RESTORE:
			restore_old_picture();
			break;
		case VERTICAL:
			do_vertical_flip();
			break;
		case HORIZON:
			do_horizonal_flip();
			break;
		case EXCHANGE:
			menu_bar(menu2_address,FALSE);
			flip_main_buffers();
			show_picture(BUFFER);
			menu_bar(menu2_address,TRUE);
			break;
		case RETURN:
TOP:		for(I=3;I<7;I++)				/* Cleans Up Dirty */
			menu_tnormal(menu2_address,I,1);/* Menu Bar.       */
			menu_bar(menu2_address,FALSE);
			menu_bar(menu1_address,TRUE);
			active_menu = TOP_MENU;
			menu_address = menu1_address;
			clear_message_buffer();
			RING_BELL();
			break;
		case GHOST:
			do_demo(7);
			break;
		case SOLID:
			do_demo(16);
			break;
		case BITBLIT:
			do_demo(blit_mode);
			break;
		case M0:
			blit_mode=0;
			break;
		case M1:
			blit_mode=1;
			break;
		case M2:
			blit_mode=2;
			break;
		case M3:
			blit_mode=3;
			break;
		case M4:
			blit_mode=4;
			break;
		case M5:
			blit_mode=5;
			break;
		case M6:
			blit_mode=6;
			break;
		case M7:
			blit_mode=7;
			break;
		case M8:
			blit_mode=8;
			break;
		case M9:
			blit_mode=9;
			break;
		case M10:
			blit_mode=10;
			break;
		case M11:
			blit_mode=11;
			break;
		case M12:
			blit_mode=12;
			break;
		case M13:
			blit_mode=13;
			break;
		case M14:
			blit_mode=14;
			break;
		case M15:
			blit_mode=15;
			break;
		case MASKED:
			blit_mode=16;
			break;
		}
		break;
	}}
	if (active_menu == DEMO_MENU && message[3] == P_MODE)
	{
	menu_ienable(menu2_address,old_mode,TRUE);	
	menu_ienable(menu2_address,message[4],FALSE);
	old_mode = message[4];
	}	
	menu_tnormal(menu_address,message[3],1);
	if (event == MU_BUTTON)
	{
	menu_bar(menu_address,FALSE);
	copy_picture(BUFFER,SHOWN);
	menu_bar(menu_address,TRUE);
	}
	if (auto_mouse_repeat == FALSE)	clear_message_buffer();
	}





introduction()
	{
	static char text1[] =
"[0][ |  RASTER SPRITE EDITOR     |          -O-     | \
Written in MegaMax C    |     Version 1.51    ][ OK | Author]";

	response = form_alert(1,text1);
	if(response == MORE) author();
	}


author()
	{
	static char text2[] =
"[0][Peter Beery |Dept. of Physics |University of \
Notre Dame|Notre Dame, In 46556       |\
Comments/Requests welcome.][ OK ]";

	form_alert(1,text2);
	}


setup()
	{
	char *temp;
		/***** Basic ST Gem Set-up *****/
	ap_id = appl_init();
	handle = graf_handle(&gl_wchar,&gl_hchar,&gl_wbox,&gl_hbox);
	for(I=0;I<10;work_in[I++]=1);
	work_in[10]=2;
	v_opnvwk(work_in,&handle,work_out);
	clip[0] = clip[1] =0;
	clip[2] = work_out[0];
	clip[3] = work_out[1];
	vs_clip(handle,TRUE,clip);
		/***** Program Set-up & Memory Allocation *****/
	default_drive = Dgetdrv() + 'A' ;
	r_w = work_out[0]+1;
	r_h = work_out[1]+1;
	graf_mouse(ARROW,0);
	v_hide_c(handle);
	for(I=0;I<16;desk_palette[I++]=Setcolor(I,-1))
	pic1_palette[I]=pic2_palette[I]=sprite_palette[I]=my_palette[I];
	palette = &pic1_palette[0];
	Setpallete(palette);
	SCREEN1 = Physbase();
	SCREEN2 = ((Malloc(32768L) & 0xffff00 ) + 0x0100);
	SPRITE  = ((Malloc(32768L) & 0xffff00 ) + 0x0100);
	MASK    = ((Malloc(32768L) & 0xffff00 ) + 0x0100);
	BUFFER1 = ((Malloc(32768L) & 0xffff00 ) + 0x0100);
	BUFFER2 = ((Malloc(32768L) & 0xffff00 ) + 0x0100);
	HIDDEN = SCREEN2;
	SHOWN  = SCREEN1;
	BUFFER = BUFFER1;
	do_backdrop("RASTER SPRITE EDITOR & SHELL",10,70);
	copy_picture(SCREEN1,BUFFER1);
	copy_picture(SCREEN1,BUFFER2);
		/***** Load & Set Resource File *****/	
	rsrc_load("raster.rsc");
	rsrc_gaddr(R_TREE,MENU1,&menu1_address);
	rsrc_gaddr(R_TREE,MENU2,&menu2_address);
	rsrc_gaddr(R_TREE,MENU3,&menu3_address);
	set_check(THIN,SPILL,FAT);    /*** Set checkmark in menu3  ***/
	menu_bar(menu1_address,TRUE);
	menu_address = menu1_address;
	set_restrictions(FALSE);
	set_mask_restrictions(FALSE);
	menu_ienable(menu2_address,RESTORE,FALSE);
	menu_ienable(menu2_address,M3,FALSE);
	RING_BELL();
	v_show_c(handle,0);
	}



exit_to_desktop()
	{
	RING_BELL();
	v_hide_c(handle);
	Setscreen(SCREEN1,SCREEN1,-1);
	Setpallete(desk_palette);
	v_clrwk(handle);
	v_clsvwk(handle);
	appl_exit();
	}




reset_palette()
	{
	int *temp;
	temp = palette;
	for ( I=0; I<16;*(temp++) = Setcolor(I++,-1) );
	}




set_restrictions(enable_flag)
	int enable_flag;
	{
	menu_ienable(menu1_address,SHOW_SPR,enable_flag);
	menu_ienable(menu1_address,SPR,enable_flag);
	menu_ienable(menu1_address,HEX,enable_flag);
	menu_ienable(menu2_address,PASTE,enable_flag);
	menu_ienable(menu2_address,GHOST,enable_flag);
	menu_ienable(menu2_address,SOLID,enable_flag);
	menu_ienable(menu2_address,BITBLIT,enable_flag);
	}



set_mask_restrictions(enable_flag)
	int enable_flag;
	{
	menu_ienable(menu1_address,MASK_SPR,enable_flag);
	menu_ienable(menu1_address,MASK_HEX,enable_flag);
	menu_ienable(menu2_address,MASKPAST,enable_flag);
	}



chose_a_file(path,purpose)
	char *path;
	int purpose;
	{
	char directory[20],name[20];
	if (purpose==LOAD)
	shadow_text(((work_out[0]/3)-7),22,"Load which file ?",2);
	else if (purpose==SAVE)
	shadow_text(((work_out[0]/3)-7),22,"Save file as :",2);
	else if (purpose != -1)
	shadow_text(((work_out[0]/4)-7),22,"Add to the end of which file :",2);
	directory[0] = default_drive;
	directory[1] = ':' ;
	strcpy(&directory[2],path);
	strcpy(name,path);
	for(I=0;I<40;filename[I++]='\0');  /*** Removes Junk characters ***/
	fsel_input(directory,name,&response);
	if(response==CANCEL) return(CANCEL);
	default_drive = directory[0];  /* Come Back To Last Directory */
	for(I=0;directory[I]!='*';filename[I++]=directory[I]);
	for(J=0;name[J]!='\0';filename[I++]=name[J++]);
	if ( purpose != -1 )copy_picture(BUFFER,SHOWN);
	shadow_text(((work_out[0]/3)-7),22,filename,2);
	return(OK);
	}



copy_picture(source,destination)
	register long *source,*destination;
	{
	register int N;
	for(N=0;(N++)<8000;*(destination++)=*(source++));
	}




do_vertical_flip()
	{
	int row_limit,column_limit;
	menu_bar(menu_address,FALSE);
	show_picture(BUFFER);
	v_hide_c(handle);
	switch ( Getrez() )
	  {	case HIGH:
			row_limit = 400;
			column_limit = 20;
			break;
		case MEDIUM:
		case LOW:
			row_limit = 200;
			column_limit = 40;
			break;
	  }
	for(I=0; I<row_limit; I++)
	for(J=0; J<column_limit; J++)
	*( (long*)BUFFER + I*column_limit + J ) =
	*( (long*)SHOWN + (row_limit-I-1)*column_limit + J );
	show_picture(BUFFER);
	menu_bar(menu_address,TRUE);
	v_show_c(handle,1);
	}


do_horizontal_flip()
	{
	register I,J,K;
	int row_limit,column_limit,unit;
	menu_bar(menu_address,FALSE);
	show_picture(BUFFER);
	v_hide_c(handle);
	switch ( Getrez() )
	  {	case HIGH:
			row_limit = 400;
			column_limit = 40;
			unit = 1;
			break;
		case MEDIUM:
			row_limit = 200;
			column_limit = 80;
			unit = 2;
			break;
		case LOW:
			row_limit = 200;
			column_limit = 80;
			unit = 4;
			break;
	  }
	for(I=0; I<row_limit; I++)
	for(J=0; J<column_limit; J = J + unit)
	for(K=0; K<unit; K++)
	  *((int*)SHOWN + I*column_limit + J +K) =interpose_bit_order(
	  *((int*)BUFFER + I*column_limit + (column_limit-unit-J) + K));
	copy_picture(SHOWN,BUFFER);
	menu_bar(menu_address,TRUE);
	v_show_c(handle,1);
	}



interpose_bit_order(ying)
	unsigned int ying;
	{
	register int M;
	unsigned int yang = 0 ,bit[16];
	bit[0] = (ying & 1) << 15;
	bit[1] = (ying & 2) << 13;
	bit[2] = (ying & 4) << 11;
	bit[3] = (ying & 8) << 9;
	bit[4] = (ying & 16) << 7;
	bit[5] = (ying & 32) << 5;
	bit[6] = (ying & 64) << 3;
	bit[7] = (ying & 128) << 1;
	bit[8] = (ying & 256) >> 1;
	bit[9] = (ying & 512) >> 3;
	bit[10] = (ying & 1024) >> 5;
	bit[11] = (ying & 2048) >> 7;
	bit[12] = (ying & 4096) >> 9;
	bit[13] = (ying & 8192) >> 11;
	bit[14] = (ying & 16384) >> 13;
	bit[15] = (ying & 32768) >> 15;
	for(M=0; M<16; yang = yang + bit[M++]);
	return(yang);
	}




clear_screen_buffer(address)
	register long *address;	
	{
	register int N;
	for( N=0; (N++)<8000; *(address++) = 0 );
	}




clear_message_buffer()
	{
	for( I=0; I<8; message[I++]=0 );
	}



set_auto_repeat()
	{
	static char auto_text[] =
"[0][If AUTO REPEAT is   |set, then pressing  |\
the mouse button   |will repeat the    |last selection.  ]\
[ ON | OFF ]";
	but = form_alert(1,auto_text);
	if(but == NO) auto_mouse_repeat = FALSE ;
	else 
	auto_mouse_repeat = TRUE;
	}



show_picture(source)
	long source;
	{
	long temp;
	v_hide_c(handle);
	copy_picture(source,HIDDEN);
	Setpallete(palette);
	Setscreen(HIDDEN,HIDDEN,-1);
	temp = HIDDEN;
	HIDDEN = SHOWN;
	SHOWN = temp;
	v_show_c(handle,1);
	}




select_picture(type,purpose)
	int type,purpose;
	{
	int resolution;
	static char	neo_alert_text[] =
"[1][ Neochrome versions|0.5 thru 0.9 work|only in LOW resolution]\
[ ABORT|continue ]";
	
	resolution = Getrez();
	if(type==NEO)	/* NEOCHROME FORMAT */
	 {
	 if(resolution != LOW)
 	 {
	 response = form_alert(1,neo_alert_text);
	 if ( response == 1 )return (CANCEL);
	 }
	 offset[0]=4L;
	 offset[1]=128L;
	 response = chose_a_file("*.NEO",purpose);
	 }
	else		/* DEGAS FORMAT */
	 {
	 offset[0]=2L;
	 offset[1]=34L;
	 switch(resolution)
	 {
		case LOW:
			response = chose_a_file("*.PI1",purpose);
			break;
		case MEDIUM:
			response = chose_a_file("*.PI2",purpose);
			break;
		case HIGH:
			response = chose_a_file("*.PI3",purpose);
			break;
	}
	}
	if(response==CANCEL) return(CANCEL);
	else return(OK);
	}


load_picture()
	{
	int filehandle,temp[16];
	v_hide_c(handle);
	flip_main_buffers();
	filehandle=open(filename,O_BINARY);
	lseek(filehandle,offset[0],0);	/* skip header & load palette */
	read(filehandle,temp,32);
	lseek(filehandle,offset[1],0);	/*  load screen */
	read(filehandle,BUFFER,32000);
	close(filehandle);
	show_picture(BUFFER);
	v_show_c(handle,0);
	for(I=0; I<16; I++) *(palette +I)=temp[I];
	Setpallete(palette);
	RING_BELL();
	}



flip_main_buffers()
	{
	if (BUFFER == BUFFER1)
		{
		BUFFER = BUFFER2;
		palette = pic2_palette;
		}
	else 
		{
		BUFFER = BUFFER1;
		palette = pic1_palette;
		}
	Setpallete(palette);
	}



edit()
	{
	static char text_edit[] =
"[0][ |  SHOW Sprite           |  EXIT Edit Mode          |\
  BACK To Edit          ][Show|Exit|Back]",
	edit_introduction[] =
"[0][To CUT a sprite: Drag  |the LEFT mouse button. |To VIEW it or \
to EXIT: |Press the RIGHT button.  ][ OK ]";
	v_hide_c(handle);
	menu_bar(menu2_address,FALSE);
	show_picture(BUFFER);
	v_show_c(handle,0);
	form_alert(1,edit_introduction);
	graf_mouse(THIN_CROSS,0);
	while()
	{
	graf_mkstate(&p[0],&p[1],&button,&key);
	switch(button)
	{
	case 1:		/* Cut Sprite From Background */
		graf_rubberbox(p[0],p[1],0,0,&p[2],&p[3]);
		set_sprite_parameters();
		clear_screen_buffer(SPRITE);
		cut_sprite(SHOWN,SPRITE);
	case 2:		/* 'Show Sprite/Exit Edit' Dialog */
		response=form_alert(0,text_edit);
		switch(response)
		{
		case 1:		/* Show Sprite*/
			show_sprite();
			break;
		case 2:		/* Exit Edit Mode */
			v_hide_c(handle);
			menu_bar(menu2_address,TRUE);
			graf_mouse(ARROW,0);
			v_show_c(handle,0);
			return;
		}
		graf_mouse(THIN_CROSS,0);
		break;
	}
	}
	}



set_sprite_parameters()
	{
	int num,div;
	I=Getrez();
	switch(I)
	{
	case LOW:	/* 160 bytes x 200 lines <320x200 x16 > */
		div=16;
		num=2;
		rez=0;
		break;
	case MEDIUM:/* 160 bytes x 200 lines <640x200 x4 > */
		div=16;
		num=1;
		rez=1;
		break;
	case HIGH:	/* 80 bytes x 400 lines <640x400 x1 >  */
		div=32;
		num=1;
		rez=2;
		break;
	}
	p[0]= (p[0]/div)*num;
	width = ((p[2]+div)/div)*num;
	height = p[3];
	for(I=0;I<16;sprite_palette[I++]=*(palette + I));
	}


cut_sprite(s_address,d_address)
	long *s_address,*d_address;
	{
	register int row,col,size;
	if( Getrez()==HIGH ) size = 20;
	else size = 40;
	v_hide_c(handle);
	for(row=0 ; row < height ;row++ )
	for(col=0 ; col < width ;col++ )
		*(d_address + size*row + col) =
		*(s_address + size*(row+p[1]) + col + p[0]);
	v_show_c(handle,0);
	mask_exists = FALSE;
	}


show_sprite()
	{
	int answer,x,y,but,state;
	static char text_save[] =
"[0][ Save This Sprite ?  ][ Yes | No ]",
	text_format[] =
"[0][  2 bytes Resolution   |  2 bytes Width    |  2 bytes Height  |\
 32 bytes Palette  | W x H Sprite Data   ][.SPR|.HEX|bye]";
	v_hide_c(handle);
	Setscreen(SPRITE,SPRITE,-1);
	Setpallete(sprite_palette);
	v_show_c(handle,0);
	while( but != 1)vq_mouse(handle,&but,&x,&y); 
	answer = form_alert(2,text_save);
	if	( answer == NO ) goto A;
	answer = form_alert(3,text_format);
	switch (answer)
	{
	case 1: 	/* Save as '*.SPR' */
		save_spr();
		break;
	case 2:		/* Save as '*.HEX' */
		save_hex();
		break;
	}
A:	show_picture(BUFFER);
	}




call_degas()
	{
	char *no_degas =
"[0][Error loading DEGAS.|Either it isn't on  |\
drive A or there |are too many desk |\
acc.s using up memory. ][ Whoops ]";
	menu_bar(menu1_address,FALSE);
	v_hide_c(handle);
	clear_screen_buffer(SHOWN);
	v_show_c(handle,0);
	Setpallete(desk_palette);
	response = Pexec(0,"A:DEGAS.PRG","",0L);
	Setpallete(palette);
	graf_mouse(ARROW,0);
	v_show_c(handle,0);
	if (response < 0 ) 	form_alert(1,no_degas);
	show_picture(BUFFER);
	menu_bar(menu1_address,TRUE);
	}



call_neochrome()
	{
	char *no_neo =
"[0][Error loading NEO.PRG|Either it isn't on    |\
drive A or there        |are too many desk      |\
acc.s using up memory. ][ Whoops ]";
	menu_bar(menu1_address,FALSE);
	v_hide_c(handle);
	clear_screen_buffer(SHOWN);
	v_show_c(handle,0);
	Setpallete(desk_palette);
	response = Pexec(0,"A:NEO.PRG","",0L);
	Setpallete(palette);
	graf_mouse(ARROW,0);
	v_show_c(handle,0);
	if (response < 0 ) 	form_alert(1,no_neo);
	show_picture(BUFFER);
	menu_bar(menu1_address,TRUE);
	}


call_other_program()
	{
	char *no_other =
"[0][Error loading your *.PRG|Either it isn't on        |\
this drive or there      |are too many desk        |\
acc.s using up memory. ][ Whoops ]",
	*other_finished =
"[0][  |Welcome Back     |     |Run another?   ][ No | Yes ]";
	menu_bar(menu1_address,FALSE);
	v_hide_c(handle);
	clear_screen_buffer(SHOWN);
	v_show_c(handle,0);
	Setpallete(my_palette);
	response = chose_a_file("*.PRG",LOAD);
	if(response==CANCEL)
	{
	Setpallete(palette);
	show_picture(BUFFER);
	menu_bar(menu1_address,TRUE);
	return;
	}
	response = Pexec(0,filename,"",0L);
	Setpallete(palette);
	if (response < 0 ) form_alert(1,no_other);
	show_picture(BUFFER);
	v_show_c(handle,0);
	graf_mouse(ARROW,0);
	response=form_alert(1,other_finished);
	menu_bar(menu1_address,TRUE);
	if(response==MORE) call_other_program();
	}


do_backdrop(text,X,Y)
	char text[40];
	int X,Y;
	{
	wind_get(0,5,&p[0],&p[1],&p[2],&p[3]);
	v_hide_c(handle);
	vswr_mode(handle,2);		/* TRANSPARENT	  */
	vsf_interior(handle,1);		/* SOLID FILL	  */
	vsf_color(handle,3);		/* FILL COLOR=3	  */
	vr_recfl(handle,p);
	shadow_text(X,Y,text,2);
	shadow_text(X,Y+15,"TO EXIT: Click on 'GOOD BYE' ",2);
	shadow_text(X,Y+30,"      or hit any key",2);
	graf_mouse(ARROW,0);
	}



shadow_text(X,Y,text,color)
	int X,Y,color;
	char text[40];
	{
	v_hide_c(handle);
	vst_color(handle,0);		/* SHADOW COLOR=0   */
	v_gtext(handle,X+2,Y+1,text);
	if (Getrez() != HIGH && color != 0)
		{
		vst_color(handle,color);
		v_gtext(handle,X,Y,text);
		}
	v_show_c(handle,1);
	}




save_hex()
	{
	int filehandle,row,h;
	long size,*where,WHAT;
	unsigned n_chars;
	show_picture(BUFFER);
	if (Getrez()==HIGH) size = 20L;
	else size = 40L;
	response=chose_a_file("*.HEX",SAVE);
	if (response==CANCEL) goto A;
	alter_flag = 0;
	filehandle=creat(filename,O_BINARY);
	if (filehandle<0) goto A;
	h = height;
	if(message[4]==MASK_HEX)WHAT=MASK;
	else WHAT=SPRITE;
	clear_screen_buffer(HIDDEN);
	n_chars = sprintf((char *)HIDDEN,
			"**** Resolution ****\n      0x%x \n \n",rez);
	n_chars += sprintf((char *)HIDDEN+n_chars,
			"**** Width in Bytes ****\n      0x%x \n \n",width*4);
	n_chars += sprintf((char *)HIDDEN+n_chars,
			"**** Height ****\n      0x%x \n \n",h);
	n_chars += sprintf((char *)HIDDEN+n_chars,"**** Palette ****\n");
	n_chars += sprintf((char *)HIDDEN+n_chars,
			"0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x \n",
			sprite_palette[0],sprite_palette[1],sprite_palette[2],
			sprite_palette[3],sprite_palette[4],sprite_palette[5],
			sprite_palette[6],sprite_palette[7]);
	n_chars += sprintf((char *)HIDDEN+n_chars,
			"0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x,0x%03x \n",
			sprite_palette[8],sprite_palette[9],sprite_palette[10],
			sprite_palette[11],sprite_palette[12],sprite_palette[13],
			sprite_palette[14],sprite_palette[15]);
	write(filehandle,HIDDEN,n_chars);
	n_chars = sprintf((char *)HIDDEN,
			"\n******* Sprite Data ******\n");
	for(row=0;row<h;row++)
	{
	for(I=0;I< width;I++)
		{
		where = (long *)WHAT + row*size + I;
		n_chars += sprintf((char *)HIDDEN+n_chars,"0x%08lx,",*where);
		}	/* Note; The above format is '0' '8' 'small L' 'x' */
	write(filehandle,HIDDEN,n_chars);
	n_chars = sprintf((char *)HIDDEN,"\n");
	}
	close(filehandle);
A:	show_picture(BUFFER);
	RING_BELL();
	form_alert(1,done);
	}




save_spr()
	{
	int filehandle,row;
	long size,where,WHAT,offset;
	show_picture(BUFFER);
	if (Getrez()==HIGH) size = 80L;
	else size = 160L;
	response=chose_a_file("*.SPR",SAVE);
	if (response==CANCEL) goto A;
	filehandle=creat(filename,O_BINARY);
	if (filehandle<0) goto A;
	if ( message[4] == MASK_SPR ) WHAT = MASK; /*** Save Mask  ***/
	else WHAT = SPRITE;     				   /*** Or  Sprite ***/
	width = width*4;		/* Convert 'width' To # Of Bytes */
	write(filehandle,&rez,2);
	write(filehandle,&width,2);
	write(filehandle,&height,2);
	write(filehandle,sprite_palette,32);
	for(row=0;row<height;row++)
	{
	where = WHAT + (long)row*size;
	write(filehandle,where,width); /* Write One Row Of Data */
	}
	close(filehandle);
	width = width/4;  /* Convert Back To Long For This Application */
A:	show_picture(BUFFER);
	RING_BELL();
	form_alert(1,done);
	}


load_sprite()
	{
	int filehandle,row;
	long size,where;
	menu_bar(menu1_address,FALSE);
	show_picture(BUFFER);
	if (Getrez()==HIGH) size = 80L;
	else size = 160L;
	response=chose_a_file("*.SPR",LOAD);
	if (response==CANCEL) goto A;
	filehandle=open(filename,O_BINARY);
	if (filehandle<0) goto A;
	clear_screen_buffer(SPRITE);
	read(filehandle,&rez,2);
	read(filehandle,&width,2);
	read(filehandle,&height,2);
	read(filehandle,sprite_palette,32);
	for(row=0;row<height;row++)
	{
	where = SPRITE + ((long)row) * size; /* Go To Next Row */
	read(filehandle,where,width); /* Read One Row Of Data */
	}
	close(filehandle);
	width = width/4;  /* Convert Back To Long For This Application */
A:	show_picture(BUFFER);
	menu_bar(menu1_address,TRUE);
	mask_exists = FALSE;
	RING_BELL();
	form_alert(1,done);
	}



paste_sprite()
	{
	int width_in_pixels;
	char *paste_text =
"[0][|Press the LEFT mouse      |button where you    |\
want to drop the     |sprite.            ][Ok]";
	menu_bar(menu2_address,FALSE);
	show_picture(BUFFER);		/* Do Twice To Setup RESTORE */
	show_picture(BUFFER);
	form_alert(1,paste_text);
	move_sprite(&width_in_pixels,LEFT,blit_mode);
	copy_picture(BUFFER,HIDDEN); /* Save old buffer for RESTORE */
	copy_picture(SHOWN,BUFFER); /* SAVE FOR FUTURE GENERATIONS */
	menu_bar(menu2_address,TRUE);
	alter_flag = 3;
	menu_ienable(menu2_address,RESTORE,TRUE);
	v_show_c(handle,0);
	}




restore_old_picture()
	{
	long buffer;
	RING_BELL();
	menu_bar(menu2_address,FALSE);
	v_hide_c(handle);
	switch(alter_flag)
		{
		case 1:     /* Restore Sprite  */
			buffer = SPRITE;
			break;
		case 2:     /* Restore Mask    */
			buffer = MASK;
			break;
		case 3:     /* Restore Picture */
			buffer = BUFFER;
			break;
		}
	copy_picture(HIDDEN,buffer);
	show_picture(BUFFER);
	menu_bar(menu2_address,TRUE);
	v_show_c(handle,1);
	RING_BELL();
	}



move_sprite(width_in_pixels,trigger,copy_mode)
	int *width_in_pixels,trigger,copy_mode;
	{
	int sfdb[10],dfdb[10],xy[8];
	long *temp1,*temp2,WHAT;
	menu_bar(menu2_address,FALSE);
	v_hide_c(handle);
	alter_flag = 0;
		/***** Set Memory Form Definition Blocks *****/
	switch(I=Getrez())
	{
	case 0:
		J = 4;
		*width_in_pixels = (width * 8);
		break;
	case 1:
		J = 2;
		*width_in_pixels = (width * 16);
		break;
	case 2:
		J = 1;
		*width_in_pixels = (width * 32);
		break;
	}
	temp1 = (long *) &sfdb[0];
	temp2 = (long *) &dfdb[0];
	sfdb[2] = dfdb[2] = r_w;
	sfdb[3] = dfdb[3] = r_h;
	sfdb[4] = dfdb[4] = r_w/16;
	sfdb[5] = dfdb[5] = 0;
	sfdb[6] = dfdb[6] = J;
	xy[0] = xy[1] = 0;
	xy[2] = *width_in_pixels-1;
	xy[3] = height-1;
	show_picture(BUFFER);	/* Call this twice to clean */
	show_picture(BUFFER);	/* both screens.			*/
	if (copy_mode == 16 && mask_exists == FALSE)
		make_mask(*width_in_pixels,height);
	if ( message[4] == MASKPAST ) WHAT = MASK;	/*** Paste Mask   ***/
	else WHAT = SPRITE;							/*** Paste Sprite ***/
	but=0;
	while( but != trigger)
	 {
	 vq_mouse(handle,&but,&xy[4],&xy[5]);
	 if ( xy[4] > (work_out[0]-*width_in_pixels) )
	 xy[4] = (work_out[0]-*width_in_pixels);
	 if ( xy[5] > (work_out[1]-height) )
	 xy[5] = (work_out[1]-height);
	 xy[6] = xy[4]+xy[2];
	 xy[7] = xy[5]+xy[3];
	 if (copy_mode == 16)
		{					 /*****  Masked Mode *****/
		*temp1 = MASK;
		*temp2 = HIDDEN;
		vro_cpyfm(handle,1,xy,sfdb,dfdb);
		*temp1 = WHAT;
		*temp2 = HIDDEN;
		vro_cpyfm(handle,7,xy,sfdb,dfdb);
		}
	 else	/**** Any Of The Standard Raster Copy Modes ****/
		{
		*temp1 = WHAT;
		*temp2 = HIDDEN;
		vro_cpyfm(handle,copy_mode,xy,sfdb,dfdb);
		}
		show_picture(HIDDEN);/* Remember this flips SHOWN & HIDDEN */
		copy_picture(BUFFER,HIDDEN); /* Restore hidden picture   */
	 }
	}




make_mask(width_in_pixels,height)
	int width_in_pixels,height;
	{
	int pixel,color,pxy[2];
	copy_picture(SPRITE,MASK);
	Setscreen(MASK,MASK,-1);
	vsm_type(handle,1); 	/* Marker:single pixel */
	for( I=0; I<height; I++ )
	for( J=0; J<width_in_pixels;  J++ )
	{
	pxy[0]=J;
	pxy[1]=I;
	v_get_pixel(handle,J,I,&pixel,&color);
	if ( pixel == 0 )
	 { 
	 vsm_color(handle,1);
	 v_pmarker(handle,1,pxy);
	 }
	else
	 { 
	 vsm_color(handle,0);
	 v_pmarker(handle,1,pxy);
	 }}
	Setscreen(SHOWN,SHOWN,-1);
	mask_exists = TRUE;
	set_mask_restictions(TRUE);	/*** Allow Mask Operations ***/
	}




save_background(write_mode)
	int write_mode;
	{
	int choice;
	char *format =
"[0][  | Save this Picture     |with which format ?      ]\
[NEO|DEGAS|cancel]";
	menu_bar(menu1_address,FALSE);
	show_picture(BUFFER);
	choice = form_alert(3,format);
	switch(choice)
	{
	case 1:	/* Save In Neochrome Format */
		response=select_picture(NEO,write_mode);
		offset[0]=4L;
		offset[1]=92L;
		break;
	case 2:	/* Save In Degas Format */
		response=select_picture(DEGAS,write_mode);
		offset[0]=2L;
		offset[1]=0L;
		header[0]=Getrez();
		break;
	case 3:	/* Cancel Save Request */
		response=CANCEL;
	}
	if (response != CANCEL) save_picture(write_mode);
	show_picture(BUFFER);
	menu_bar(menu1_address,TRUE);
	}
	


save_picture(write_mode)
	int write_mode;
	{
	int filehandle;
	v_hide_c(handle);
	if ( write_mode != APPEND )	/*** Create A New File. ***/
	{
	filehandle=creat(filename,O_BINARY);
	write(filehandle,header,(unsigned)offset[0]);
	write(filehandle,palette,32);
	write(filehandle,filler,(unsigned)offset[1]);
	}
	else		/*** Add It To The End Of The Chosen File. ***/
	{
	filehandle = open(filename,O_BINARY|O_RDWR);
	lseek(filehandle,0L,2);
	}
	write(filehandle,BUFFER,32000);
	close(filehandle);
	v_show_c(handle,0);
	RING_BELL();
	form_alert(1,done);
	}




do_demo(copy_mode)
	int copy_mode;
	{
	int width_in_pixels;
	char *demo_text =
"[0][|Press the RIGHT   |mouse button to |leave this demo |\
routine.     ][Ok]";
	form_alert(1,demo_text);
	move_sprite(&width_in_pixels,RIGHT,copy_mode);
	show_picture(BUFFER);
	menu_bar(menu2_address,TRUE);
	v_show_c(handle,0);
	}


